﻿using Csla;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace WisejWebApplication2.BO
{
	[Serializable]
	public class Head : BusinessBase<Head>
	{
		public static readonly PropertyInfo<string> Info1Property = RegisterProperty<string>(p => p.Info1, "Info1");
		public string Info1
		{
			get { return GetProperty(Info1Property); }
			set { SetProperty(Info1Property, value); }
		}

		public static readonly PropertyInfo<string> Info2Property = RegisterProperty<string>(p => p.Info2, "Info2");
		public string Info2
		{
			get { return GetProperty(Info2Property); }
			set { SetProperty(Info2Property, value); }
		}

		public static readonly PropertyInfo<Knights> KnightsProperty = RegisterProperty<Knights>(c => c.Knights, Csla.RelationshipTypes.Child);
		public Knights Knights
		{
			get
			{
				if (GetProperty(KnightsProperty) == null)
				{
					LoadProperty(KnightsProperty, DataPortal.CreateChild<Knights>());
				}
				return GetProperty(KnightsProperty);
			}
		}

		public static Head GetHead()
		{
			return DataPortal.Fetch<Head>();
		}

		private void DataPortal_Fetch()
		{
			LoadProperty(Info1Property, "First info");
			LoadProperty(Info2Property, "Second info");
			LoadProperty(KnightsProperty, DataPortal.FetchChild<Knights>());
		}

	}
}