﻿using Csla;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace WisejWebApplication2.BO
{
    [Serializable]
    public class Son : BusinessBase<Son>
    {

        public static readonly PropertyInfo<string> NameProperty = RegisterProperty<string>(p => p.Name, "Name");
        public string Name
        {
            get { return GetProperty(NameProperty); }
            set { SetProperty(NameProperty, value); }
        }

        public static readonly PropertyInfo<bool> GoodGuyProperty = RegisterProperty<bool>(p => p.GoodGuy, "GoodGuy");
        public bool GoodGuy
        {
            get { return GetProperty(GoodGuyProperty); }
            set { SetProperty(GoodGuyProperty, value); }
        }

        public static readonly PropertyInfo<string> TitleProperty = RegisterProperty<string>(p => p.Title, "Title");
        public string Title
        {
            get { return GetProperty(TitleProperty); }
            set { SetProperty(TitleProperty, value); }
        }

        public static readonly PropertyInfo<string> TekstProperty = RegisterProperty<string>(p => p.Tekst, "Tekst");
        public string Tekst
        {
            get { return GetProperty(TekstProperty); }
            set { SetProperty(TekstProperty, value); }
        }

        public static readonly PropertyInfo<Childs> ChildsProperty = RegisterProperty<Childs>(c => c.Childs, Csla.RelationshipTypes.Child);
        public Childs Childs
        {
            get
            {
                if (GetProperty(ChildsProperty) == null)
                {
                    LoadProperty(ChildsProperty, DataPortal.CreateChild<Childs>());
                }
                return GetProperty(ChildsProperty);
            }
        }

        private void Child_Fetch(string Name, bool GoodGuy, string Title)
        {
            using (BypassPropertyChecks)
            {
                LoadProperty(NameProperty, Name);
                LoadProperty(GoodGuyProperty, GoodGuy);
                LoadProperty(TitleProperty, Title);
            }
            LoadProperty(ChildsProperty, DataPortal.FetchChild<Childs>(Name));
        }

    }
}